window.Gleam.initSearch([{"doc":"novdom_dev_tools","title":"novdom_dev_tools","content":"# novdom_dev_tools\n\nThe dev tools for the [novdom](https://github.com/TobiasBinnewies/novdom) framework.\n\nUse it for testing (`novdom_dev_tools/testing`) and ~~bundling / hot reloading~~ *(not working yet)*\n\n# Commands\n\n- install: Installs Esbuild and Tailwind\n- build: Builds the project (with --prod flag for production)\n- dev: Starts the dev server (With hot reloading)\n","url":"index.html"},{"doc":"dev_tools/internals/error","title":"Error","content":"pub type Error {\n  BuildError(reason: String)\n  BundleError(reason: String)\n  CannotCreateDirectory(\n    reason: simplifile.FileError,\n    path: String,\n  )\n  CannotReadFile(reason: simplifile.FileError, path: String)\n  CannotSetPermissions(\n    reason: simplifile.FileError,\n    path: String,\n  )\n  CannotStartDevServer(reason: glisten.StartError)\n  CannotStartFileWatcher(reason: actor.StartError)\n  CannotWriteFile(reason: simplifile.FileError, path: String)\n  ComponentMissing(module: String)\n  IncompleteProxy(missing: List(String))\n  InternalError(message: String)\n  InvalidProxyTarget(to: String)\n  MainBadAppType(\n    module: String,\n    flags: Type,\n    model: Type,\n    msg: Type,\n  )\n  MainMissing(module: String)\n  MainTakesAnArgument(module: String, got: Type)\n  ModuleMissing(module: String)\n  NameIncorrectType(module: String, got: Type)\n  NameMissing(module: String)\n  NetworkError(Dynamic)\n  TemplateMissing(name: String, reason: simplifile.FileError)\n  UnknownPlatform(binary: String, os: String, cpu: String)\n  OtpTooOld(version: Int)\n  UnzipError(Dynamic)\n  InvalidEsbuildBinary\n  InvalidTailwindBinary\n  DependencyInstallationError(\n    reason: String,\n    package_manager: String,\n  )\n}\n\nBuildError(reason: String)\n\n\nBundleError(reason: String)\n\n\nCannotCreateDirectory(reason: simplifile.FileError, path: String)\n\n\nCannotReadFile(reason: simplifile.FileError, path: String)\n\n\nCannotSetPermissions(reason: simplifile.FileError, path: String)\n\n\nCannotStartDevServer(reason: glisten.StartError)\n\n\nCannotStartFileWatcher(reason: actor.StartError)\n\n\nCannotWriteFile(reason: simplifile.FileError, path: String)\n\n\nComponentMissing(module: String)\n\n\nIncompleteProxy(missing: List(String))\n\n\nInternalError(message: String)\n\n\nInvalidProxyTarget(to: String)\n\n\nMainBadAppType(\n  module: String,\n  flags: Type,\n  model: Type,\n  msg: Type,\n)\n\n\nMainMissing(module: String)\n\n\nMainTakesAnArgument(module: String, got: Type)\n\n\nModuleMissing(module: String)\n\n\nNameIncorrectType(module: String, got: Type)\n\n\nNameMissing(module: String)\n\n\nNetworkError(Dynamic)\n\n\nTemplateMissing(name: String, reason: simplifile.FileError)\n\n\nUnknownPlatform(binary: String, os: String, cpu: String)\n\n\nOtpTooOld(version: Int)\n\n\nUnzipError(Dynamic)\n\n\nInvalidEsbuildBinary\n\n\nInvalidTailwindBinary\n\n\nDependencyInstallationError(\n  reason: String,\n  package_manager: String,\n)\n\n\nSynonyms:\ndev_tools/internals/error.Error\ndev_tools/internals/error Error","url":"dev_tools/internals/error.html#Error"},{"doc":"dev_tools/internals/error","title":"explain","content":"pub fn explain(error: Error) -&gt; Nil\n\nSynonyms:\ndev_tools/internals/error.explain\ndev_tools/internals/error explain","url":"dev_tools/internals/error.html#explain"},{"doc":"dev_tools/internals/error","title":"invalid_proxy_target","content":"pub fn invalid_proxy_target(to: String) -&gt; String\n\nSynonyms:\ndev_tools/internals/error.invalid_proxy_target\ndev_tools/internals/error invalid_proxy_target","url":"dev_tools/internals/error.html#invalid_proxy_target"},{"doc":"dev_tools/internals/error","title":"dev_tools/internals/error","content":"","url":"dev_tools/internals/error.html"},{"doc":"dev_tools/internals/cmd","title":"cwd","content":"pub fn cwd() -&gt; Result(String, Dynamic)\n\n\nSynonyms:\ndev_tools/internals/cmd.cwd\ndev_tools/internals/cmd cwd","url":"dev_tools/internals/cmd.html#cwd"},{"doc":"dev_tools/internals/cmd","title":"exec","content":"pub fn exec(\n  run command: String,\n  with args: List(String),\n  in in: String,\n) -&gt; Result(String, #(Int, String))\n\n\nSynonyms:\ndev_tools/internals/cmd.exec\ndev_tools/internals/cmd exec","url":"dev_tools/internals/cmd.html#exec"},{"doc":"dev_tools/internals/cmd","title":"dev_tools/internals/cmd","content":"","url":"dev_tools/internals/cmd.html"},{"doc":"dev_tools/internals/project","title":"Config","content":"pub type Config {\n  Config(name: String, version: String, toml: Dict(String, Toml))\n}\n\nConfig(name: String, version: String, toml: Dict(String, Toml))\n\n\nSynonyms:\ndev_tools/internals/project.Config\ndev_tools/internals/project Config","url":"dev_tools/internals/project.html#Config"},{"doc":"dev_tools/internals/project","title":"Function","content":"pub type Function {\n  Function(parameters: List(Type), return: Type)\n}\n\nFunction(parameters: List(Type), return: Type)\n\n\nSynonyms:\ndev_tools/internals/project.Function\ndev_tools/internals/project Function","url":"dev_tools/internals/project.html#Function"},{"doc":"dev_tools/internals/project","title":"Interface","content":"pub type Interface {\n  Interface(\n    name: String,\n    version: String,\n    modules: Dict(String, Module),\n  )\n}\n\nInterface(\n  name: String,\n  version: String,\n  modules: Dict(String, Module),\n)\n\n\nSynonyms:\ndev_tools/internals/project.Interface\ndev_tools/internals/project Interface","url":"dev_tools/internals/project.html#Interface"},{"doc":"dev_tools/internals/project","title":"Module","content":"pub type Module {\n  Module(\n    constants: Dict(String, Type),\n    functions: Dict(String, Function),\n  )\n}\n\nModule(\n  constants: Dict(String, Type),\n  functions: Dict(String, Function),\n)\n\n\nSynonyms:\ndev_tools/internals/project.Module\ndev_tools/internals/project Module","url":"dev_tools/internals/project.html#Module"},{"doc":"dev_tools/internals/project","title":"build","content":"pub fn build() -&gt; Result(Nil, Error)\n Compile the current project running the `gleam build` command.\n\nSynonyms:\ndev_tools/internals/project.build\ndev_tools/internals/project build","url":"dev_tools/internals/project.html#build"},{"doc":"dev_tools/internals/project","title":"config","content":"pub fn config() -&gt; Result(Config, Error)\n Read the project configuration in the `gleam.toml` file.\n\nSynonyms:\ndev_tools/internals/project.config\ndev_tools/internals/project config","url":"dev_tools/internals/project.html#config"},{"doc":"dev_tools/internals/project","title":"interface","content":"pub fn interface() -&gt; Result(Interface, Error)\n\nSynonyms:\ndev_tools/internals/project.interface\ndev_tools/internals/project interface","url":"dev_tools/internals/project.html#interface"},{"doc":"dev_tools/internals/project","title":"otp_version","content":"pub fn otp_version() -&gt; Int\n\nSynonyms:\ndev_tools/internals/project.otp_version\ndev_tools/internals/project otp_version","url":"dev_tools/internals/project.html#otp_version"},{"doc":"dev_tools/internals/project","title":"root","content":"pub fn root() -&gt; String\n Finds the path leading to the project&#39;s root folder. This recursively walks\n up from the current directory until it finds a `gleam.toml`.\n\nSynonyms:\ndev_tools/internals/project.root\ndev_tools/internals/project root","url":"dev_tools/internals/project.html#root"},{"doc":"dev_tools/internals/project","title":"type_to_string","content":"pub fn type_to_string(type_: Type) -&gt; String\n\nSynonyms:\ndev_tools/internals/project.type_to_string\ndev_tools/internals/project type_to_string","url":"dev_tools/internals/project.html#type_to_string"},{"doc":"dev_tools/internals/project","title":"dev_tools/internals/project","content":"","url":"dev_tools/internals/project.html"},{"doc":"dev_tools/internals/cli","title":"Cli","content":"pub opaque type Cli(a)\n\n\n\nSynonyms:\ndev_tools/internals/cli.Cli\ndev_tools/internals/cli Cli","url":"dev_tools/internals/cli.html#Cli"},{"doc":"dev_tools/internals/cli","title":"do","content":"pub fn do(step: Cli(a), then next: fn(a) -&gt; Cli(b)) -&gt; Cli(b)\n\n\nSynonyms:\ndev_tools/internals/cli.do\ndev_tools/internals/cli do","url":"dev_tools/internals/cli.html#do"},{"doc":"dev_tools/internals/cli","title":"from_result","content":"pub fn from_result(result: Result(a, Error)) -&gt; Cli(a)\n\nSynonyms:\ndev_tools/internals/cli.from_result\ndev_tools/internals/cli from_result","url":"dev_tools/internals/cli.html#from_result"},{"doc":"dev_tools/internals/cli","title":"get_bool","content":"pub fn get_bool(\n  name: String,\n  fallback: Bool,\n  namespace: List(String),\n  flag: fn(Flags) -&gt; Result(Bool, a),\n) -&gt; Cli(Bool)\n\nSynonyms:\ndev_tools/internals/cli.get_bool\ndev_tools/internals/cli get_bool","url":"dev_tools/internals/cli.html#get_bool"},{"doc":"dev_tools/internals/cli","title":"get_config","content":"pub fn get_config() -&gt; Cli(Config)\n\nSynonyms:\ndev_tools/internals/cli.get_config\ndev_tools/internals/cli get_config","url":"dev_tools/internals/cli.html#get_config"},{"doc":"dev_tools/internals/cli","title":"get_config_value","content":"pub fn get_config_value(\n  name: String,\n  fallback: a,\n  namespace: List(String),\n  toml: fn(Dict(String, Toml), List(String)) -&gt; Result(a, b),\n  flag: fn(Flags) -&gt; Result(a, c),\n) -&gt; Cli(a)\n\nSynonyms:\ndev_tools/internals/cli.get_config_value\ndev_tools/internals/cli get_config_value","url":"dev_tools/internals/cli.html#get_config_value"},{"doc":"dev_tools/internals/cli","title":"get_flags","content":"pub fn get_flags() -&gt; Cli(Flags)\n\nSynonyms:\ndev_tools/internals/cli.get_flags\ndev_tools/internals/cli get_flags","url":"dev_tools/internals/cli.html#get_flags"},{"doc":"dev_tools/internals/cli","title":"get_int","content":"pub fn get_int(\n  name: String,\n  fallback: Int,\n  namespace: List(String),\n  flag: fn(Flags) -&gt; Result(Int, a),\n) -&gt; Cli(Int)\n\nSynonyms:\ndev_tools/internals/cli.get_int\ndev_tools/internals/cli get_int","url":"dev_tools/internals/cli.html#get_int"},{"doc":"dev_tools/internals/cli","title":"get_name","content":"pub fn get_name() -&gt; Cli(String)\n\nSynonyms:\ndev_tools/internals/cli.get_name\ndev_tools/internals/cli get_name","url":"dev_tools/internals/cli.html#get_name"},{"doc":"dev_tools/internals/cli","title":"get_string","content":"pub fn get_string(\n  name: String,\n  fallback: String,\n  namespace: List(String),\n  flag: fn(Flags) -&gt; Result(String, a),\n) -&gt; Cli(String)\n\nSynonyms:\ndev_tools/internals/cli.get_string\ndev_tools/internals/cli get_string","url":"dev_tools/internals/cli.html#get_string"},{"doc":"dev_tools/internals/cli","title":"in","content":"pub fn in(value: fn() -&gt; a) -&gt; Cli(a)\n\nSynonyms:\ndev_tools/internals/cli.in\ndev_tools/internals/cli in","url":"dev_tools/internals/cli.html#in"},{"doc":"dev_tools/internals/cli","title":"log","content":"pub fn log(message: String, then next: fn() -&gt; Cli(a)) -&gt; Cli(a)\n\n\nSynonyms:\ndev_tools/internals/cli.log\ndev_tools/internals/cli log","url":"dev_tools/internals/cli.html#log"},{"doc":"dev_tools/internals/cli","title":"map","content":"pub fn map(step: Cli(a), then next: fn(a) -&gt; b) -&gt; Cli(b)\n\nSynonyms:\ndev_tools/internals/cli.map\ndev_tools/internals/cli map","url":"dev_tools/internals/cli.html#map"},{"doc":"dev_tools/internals/cli","title":"mute","content":"pub fn mute() -&gt; Cli(Nil)\n\nSynonyms:\ndev_tools/internals/cli.mute\ndev_tools/internals/cli mute","url":"dev_tools/internals/cli.html#mute"},{"doc":"dev_tools/internals/cli","title":"notify","content":"pub fn notify(\n  message: String,\n  then next: fn() -&gt; Cli(a),\n) -&gt; Cli(a)\n\nSynonyms:\ndev_tools/internals/cli.notify\ndev_tools/internals/cli notify","url":"dev_tools/internals/cli.html#notify"},{"doc":"dev_tools/internals/cli","title":"return","content":"pub fn return(value: a) -&gt; Cli(a)\n\n\nSynonyms:\ndev_tools/internals/cli.return\ndev_tools/internals/cli return","url":"dev_tools/internals/cli.html#return"},{"doc":"dev_tools/internals/cli","title":"run","content":"pub fn run(step: Cli(a), flags: Flags) -&gt; Result(a, Error)\n\n\nSynonyms:\ndev_tools/internals/cli.run\ndev_tools/internals/cli run","url":"dev_tools/internals/cli.html#run"},{"doc":"dev_tools/internals/cli","title":"success","content":"pub fn success(\n  message: String,\n  then next: fn() -&gt; Cli(a),\n) -&gt; Cli(a)\n\nSynonyms:\ndev_tools/internals/cli.success\ndev_tools/internals/cli success","url":"dev_tools/internals/cli.html#success"},{"doc":"dev_tools/internals/cli","title":"template","content":"pub fn template(\n  name: String,\n  then next: fn(String) -&gt; Cli(a),\n) -&gt; Cli(a)\n\nSynonyms:\ndev_tools/internals/cli.template\ndev_tools/internals/cli template","url":"dev_tools/internals/cli.html#template"},{"doc":"dev_tools/internals/cli","title":"throw","content":"pub fn throw(error: Error) -&gt; Cli(a)\n\n\nSynonyms:\ndev_tools/internals/cli.throw\ndev_tools/internals/cli throw","url":"dev_tools/internals/cli.html#throw"},{"doc":"dev_tools/internals/cli","title":"try","content":"pub fn try(\n  result: Result(a, Error),\n  then next: fn(a) -&gt; Cli(b),\n) -&gt; Cli(b)\n\n\nSynonyms:\ndev_tools/internals/cli.try\ndev_tools/internals/cli try","url":"dev_tools/internals/cli.html#try"},{"doc":"dev_tools/internals/cli","title":"unmute","content":"pub fn unmute() -&gt; Cli(Nil)\n\nSynonyms:\ndev_tools/internals/cli.unmute\ndev_tools/internals/cli unmute","url":"dev_tools/internals/cli.html#unmute"},{"doc":"dev_tools/internals/cli","title":"dev_tools/internals/cli","content":" The `cli` module is how we create &quot;scripts&quot; that are intended to be run from\n the command line.","url":"dev_tools/internals/cli.html"},{"doc":"dev_tools/internals/structure","title":"command","content":"pub fn command() -&gt; Command(Nil)\n\nSynonyms:\ndev_tools/internals/structure.command\ndev_tools/internals/structure command","url":"dev_tools/internals/structure.html#command"},{"doc":"dev_tools/internals/structure","title":"create","content":"pub fn create() -&gt; Cli(Nil)\n\nSynonyms:\ndev_tools/internals/structure.create\ndev_tools/internals/structure create","url":"dev_tools/internals/structure.html#create"},{"doc":"dev_tools/internals/structure","title":"dev_tools/internals/structure","content":"","url":"dev_tools/internals/structure.html"},{"doc":"dev_tools/dev","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\ndev_tools/dev.main\ndev_tools/dev main","url":"dev_tools/dev.html#main"},{"doc":"dev_tools/dev","title":"dev_tools/dev","content":"","url":"dev_tools/dev.html"},{"doc":"dev_tools/internals/esbuild","title":"dev_tools/internals/esbuild","content":"","url":"dev_tools/internals/esbuild.html"},{"doc":"novdom_dev_tools/testing","title":"component_in_document","content":"pub fn component_in_document(comp_id: String) -&gt; Bool\n\nSynonyms:\nnovdom_dev_tools/testing.component_in_document\nnovdom_dev_tools/testing component_in_document","url":"novdom_dev_tools/testing.html#component_in_document"},{"doc":"novdom_dev_tools/testing","title":"trigger_event","content":"pub fn trigger_event(comp_id: String, event: String) -&gt; Nil\n\nSynonyms:\nnovdom_dev_tools/testing.trigger_event\nnovdom_dev_tools/testing trigger_event","url":"novdom_dev_tools/testing.html#trigger_event"},{"doc":"novdom_dev_tools/testing","title":"novdom_dev_tools/testing","content":"","url":"novdom_dev_tools/testing.html"},{"doc":"novdom_ui/panel","title":"novdom_ui/panel","content":"","url":"novdom_ui/panel.html"}]);